<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Semantic Object Data Model</title>
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
</head>
<body>
<div
 style="text-align: center; font-family: helvetica,arial,sans-serif;"><big><big><b>Unified
Modeling Language (UML)<br>
<br>
</b></big></big>
<center>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; height: 31px; width: 458px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; text-align: center;"><a
 href="http://safari.bvdep.com/JVXSL.asp?x=1&amp;mode=section&amp;sortKey=rank&amp;sortOrder=desc&amp;view=book&amp;xmlid=0-201-57168-4&amp;open=false&amp;g=&amp;srchText=uml+users+guide&amp;code=&amp;h=&amp;m=&amp;l=1&amp;catid=&amp;s=1&amp;b=1&amp;f=1&amp;t=1&amp;c=1&amp;u=1&amp;r=&amp;o=1&amp;page=0"
 style="font-weight: bold;">The Unified Modeling Language User Guide</a><br>
      <div align="center"><img src="0201571684_xs.jpg" alt=""> <br>
      </div>
      </td>
      <td style="vertical-align: top; text-align: center;"
 align="center"><b><a
 href="http://safari.bvdep.com/JVXSL.asp?x=1&amp;mode=section&amp;sortKey=rank&amp;sortOrder=desc&amp;view=book&amp;xmlid=0-201-65783-X&amp;open=false&amp;g=&amp;srchText=uml+distilled&amp;code=&amp;h=&amp;m=&amp;l=1&amp;catid=&amp;s=1&amp;b=1&amp;f=1&amp;t=1&amp;c=1&amp;u=1&amp;r=&amp;o=1&amp;page=0">UML
Distilled: A Brief Guide to the Standard Object Modeling Language,
Second Edition</a><br>
      </b><img src="020165783X_xs.jpg" alt=""> <br>
      </td>
    </tr>
  </tbody>
</table>
</center>
<b><br>
</b></div>
<div align="center" style="font-family: helvetica,arial,sans-serif;"> </div>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">The <a
 href="http://www.omg.org/">Object Management Group's (OMG)</a> website
has the current specifications, papers and articles on the <a
 href="week1.html#uml">Unified
Modeling Language (UML)</a>. UML was founded by three authors known as
the "Three Amigos (Booch, Jacobson, Rumbaugh)".&nbsp; </font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">UML is a modeling
language that focuses on the conceptual and physical representation of
a system.
&nbsp;UML is used for both analysis and design of software and produces
several types of artifacts required for a software project, e.g.
requirements,
architecture, design, source code, project plans, tests, prototypes and
releases.&nbsp; </font><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">Grady Booch's
original
work described objects and their relationships, James Rumbaugh provided
the
Object-Modeling Technique (OMT) and Ivar Jacobson provided the use case
methodology
approach.&nbsp; Together these founding authors and others
combined
their work into what is known today as UML. &nbsp; <a href="#uml">UML
1.0</a>
was offered for standardization to the Object Management Group (OMG) in
January
1997.<br>
</font>
<table border="0" cellspacing="0" cellpadding="0" align="left"
 style="font-family: helvetica,arial,sans-serif;">
  <tbody>
    <tr>
    </tr>
    <tr>
    </tr>
  </tbody>
</table>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><br>
The U</font><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">ML has the following
standard diagrams and we will go into each of these in this order
throughout the course:<br>
</font>
<ul style="font-family: helvetica,arial,sans-serif;">
  <li>Use Case Diagram - this is the first diagram used when building
a system.&nbsp; The Use Case Diagram contains the Actors (<span
 class="HandaWebBody">interacts with the system, such as
humans, computer systems, databases, etc.&nbsp; <span
 style="font-weight: bold;">Actors </span>take on different roles
depending on what the goal is at any given moment</span>, drawn as a
stick figure) and <span style="font-weight: bold;">Use</span> <span
 style="font-weight: bold;">Cases </span>(sequence of actions that
provide something of measurable value, drawn as a horizontal ellipse)
and the relationships between them.&nbsp; The
Use Case Diagram the most important of all UML diagrams enables both
customers,
stakeholders, designers and developers to visualize how a software
project will be
constructed
and what is expected from all stakeholders.</li>
</ul>
<div align="center" style="font-family: helvetica,arial,sans-serif;">
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 494px; height: 335px; margin-left: auto; margin-right: auto;">
  <tbody>
    <tr align="center">
      <td style="vertical-align: top;"><img
 src="file:///C:/estey/bob/html/uob/computing/databases/dbm405/week1/useCase.jpg"
 title="" alt="" style="width: 482px; height: 296px;"></td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Figure
1 - Use Case Diagram</span><br>
      </td>
    </tr>
  </tbody>
</table>
&nbsp;
<br>
<span style="font-weight: bold;">Please see an example of a Use Case
Scenario at the the end of the Lecture, just above the Semantic Object
Data Model (SODM)</span><br>
</div>
<ul style="font-family: helvetica,arial,sans-serif;">
  <li>Activity Diagram - models the logic of a use case.&nbsp; Activity
Diagrams enable you to depict both standard and alternate flows of a
program.&nbsp; Activity diagrams can also be drawn that cover several
use cases or a small portion of a use case.&nbsp; You can also use
activity diagrams without
use cases being involved at all, e.g. a larger business process.&nbsp;
Remember Activity diagrams while providing simular services like the
Sequence Diagram show how the logic flows, not the specific sequence
between objects.</li>
</ul>
<center>
<div
 style="text-align: center; font-family: helvetica,arial,sans-serif;">
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 439px; height: 653px; margin-left: auto; margin-right: auto;">
  <tbody>
    <tr align="center">
      <td style="vertical-align: top;"><img
 src="file:///C:/estey/bob/html/uob/computing/databases/dbm405/week1/activityDiagram.jpg"
 title="" alt="" style="width: 426px; height: 614px;"></td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Figure
2- Activity Diagram</span></td>
    </tr>
  </tbody>
</table>
<ul style="text-align: left;">
  <li>&nbsp; Sequence Diagram - validate the logic
of a scenario, usually the scenarios that were developed from a use
case.&nbsp; Sequence Diagrams provide a way to visualize the operations
defined by your classes and detect bottlenecks within an
object-oriented design.&nbsp; The Sequence Diagram is a popular diagram
because they are the preliminary diagrams used just before the Class
Diagrams and identify all the Interfaces, Messaging required for the
software program.&nbsp; Sequence Diagrams have the objects aligned
horizontally with lines going down from the object.&nbsp; Messaging is
displayed by drawing a line between the object lines, messaging is
displayed in order from top to bottom.</li>
</ul>
</div>
<ul style="font-family: helvetica,arial,sans-serif;">
</ul>
<div align="center" style="font-family: helvetica,arial,sans-serif;">
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 675px; height: 348px;">
  <tbody>
    <tr>
      <td style="vertical-align: top;"><img
 src="file:///C:/estey/bob/html/uob/computing/databases/dbm405/week1/sequenceDiagram.jpg"
 title="" alt="" style="width: 666px; height: 308px;"></td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Figure
3 - Sequence Diagram</span><br>
      </td>
    </tr>
  </tbody>
</table>
<small><small></small></small> <br>
</div>
<ul style="font-family: helvetica,arial,sans-serif;">
  <li style="text-align: left;">Communication Diagram - formerly known
as the Collaboration
Diagram is very simular to the Sequence Diagram, both visually and
functionality.&nbsp; The only difference is each object is defined in a
square and all messaging is defined using arrows with numbers
identifying the message sequence.</li>
</ul>
<ul style="font-family: helvetica,arial,sans-serif;">
  <li style="text-align: left;">Class Diagram - this diagram contains
the class icon, which is a
rectangular shape with three sections.&nbsp; The top section is the
name of
the class.&nbsp; The middle section contains the attributes (variables,
states)
of the particular Object.&nbsp; The bottom section is the methods
(procedures,
behavior) of the Object.&nbsp; Class diagrams are developed primarily
for
the developer to write software that conforms exactly how to build
class
files in Object-Oriented languages, e.g. Java, C++.&nbsp; Class
diagrams
also show inheritance and relationships between different classes.</li>
</ul>
<div align="center" style="font-family: helvetica,arial,sans-serif;">
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 613px; height: 200px;">
  <tbody>
    <tr align="center">
      <td style="vertical-align: top;"><img
 src="file:///C:/estey/bob/html/uob/computing/databases/dbm405/week1/classDiagram.jpg"
 title="" alt="" style="width: 601px; height: 166px;"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Figure
4 - Class Diagram</span><br>
      </td>
    </tr>
  </tbody>
</table>
&nbsp;<br>
<div style="margin-left: 40px; text-align: left;">Additional notes on
Class diagrams, <a
 href="file:///C:/estey/bob/html/uob/computing/databases/dbm405/week1/week1.html#stereotype">stereotypes</a>.&nbsp;
These are
used to categorize the type of class your diagramming.&nbsp; There are
three very popular stereotypes, Bounday, Entity and Controller.<br>
</div>
<div style="text-align: left;"></div>
<ul style="margin-left: 40px; text-align: left;">
  <li><font size="2"><span style="font-size: 10pt;">The Boundary
stereotype, represents the interface between
the use case and the actor.&nbsp; When an actor interacts</span></font><font
 size="2"><span style="font-size: 10pt;"> with the use case, this would
be through a boundary
class.&nbsp; There should be at least one for every actor &#8211; use case
interaction.</span></font></li>
  <li><font size="2"><span style="font-size: 10pt;">The Entity
stereotype represents classes that are persistent.&nbsp;
They would actually represent the tables, records, etc. in the database.</span></font></li>
  <li><font size="2"><span style="font-size: 10pt;">The Controller
stereotype represents classes that delegate
work.&nbsp; They don&#8217;t actually carry out true functionality and </span></font><font
 size="2"><span style="font-size: 10pt;">manage the use case.&nbsp; If
a
class sends a message to it, it would call another class.</span></font></li>
</ul>
<div style="text-align: left;"></div>
<div></div>
</div>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif;">
  <li style="text-align: left;">State Diagram<big><small> - </small><font
 size="-1"><big>this
diagram helps the developer to understand the details, modes and
transitions that an Object can go through with the occurrence of any
event or action.</big></font></big><font size="-1"><big>&nbsp; State
diagrams (also called State Chart diagrams)
are used to help the developer better understand any complex/unusual
functionalities or business flows of specialized areas of the
system.&nbsp; State diagrams depict the dynamic behavior of the entire
system, sub-system, or a single object in a system.&nbsp;&nbsp; S</big></font>tate
diagrams consist of states, transitions, events and activities.<span
 style=""><br>
    </span></li>
</ul>
<div align="center" style="font-family: helvetica,arial,sans-serif;">
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 399px; height: 425px;">
  <tbody>
    <tr align="center">
      <td style="vertical-align: top;"><img
 src="file:///C:/estey/bob/html/uob/computing/databases/dbm405/week1/stateDiagram.jpg"
 title="" alt="" style="width: 586px; height: 406px;"><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Figure
5 - State Diagram</span><br>
      </td>
    </tr>
  </tbody>
</table>
&nbsp;<font size="-1"><b><em></em></b></font><br>
<font size="-1"><b><em> </em></b></font></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Component Diagram - models the high-level software components and
the interfaces to those components.&nbsp; Once the interfaces are
defined, component diagrams organize the development effort between
subteams.&nbsp; When there are new requirements or changes to the
system design, the Component Diagram enables the appropriate
implementation between teams.<br>
  </li>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif;">
  <li style="text-align: left;">Deployment Diagram - this diagram shows
the hardware, the
software that is installed and the middleware used to connect the
disparate nodes.&nbsp; Deployment Diagrams are a static view of the
run-time configuration of processing nodes and the components that run
on those nodes.&nbsp; Deployment Diagrams are used for applications
that are deployed on several machines, e.g. Enterprise Software
Applications using Java 2 Enterprise Edition (J2EE).</li>
</ul>
<div align="center" style="font-family: helvetica,arial,sans-serif;">
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 396px; height: 339px;">
  <tbody>
    <tr align="center">
      <td style="vertical-align: top;"><img
 src="file:///C:/estey/bob/html/uob/computing/databases/dbm405/week1/deploymentDiagram.gif"
 title="" alt="" style="width: 385px; height: 299px;"></td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Figure
6 - Deployment Diagram</span><br>
      </td>
    </tr>
  </tbody>
</table>
&nbsp;<br>
</div>
<div align="center" style="font-family: helvetica,arial,sans-serif;"><big><big><b><a
 href="http://www.acm.org/crossroads/xrds7-3/ordbms.html">Databases</a></b></big></big><br>
</div>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><br>
</font>
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">Databases have been a
popular medium for accessing, managing and
storing data. &nbsp;There are several types of databases Network,
Hierarchial, Relational, Object-Oriented,&nbsp; Object-Relational, etc.
&nbsp;A <a href="#omg">DBMS</a> must support persistence, secondary
storage management, concurrency, recovery and an ad hoc query facility.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Relational (RDBMS) - the relational database was invented by E.
F. Codd in 1970 and is the most common type of database that provides
access and organization of data using tables. &nbsp;Tables are row /
column (two dimensional) structures that contain data or reference
other tables, tables are sometimes called relations. &nbsp;Relational
databases use the Structured Query Language (SQL) to gather information
from the database.</li>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Object-Oriented (OODBMS or ODBMS) - these databases have become
popular with the acceptance of Object-Oriented Programming Languages
(OOPL).
&nbsp;OOPL trace their roots back to Simula in 1962 but didn't catch on
until Smalltalk in 1980, C++ a few years later and then finally Java in
1995. &nbsp;With the reemergence of OOPL the data has changed from a
state
only database, e.g. relational to state and behavior database, e.g.
Object-Oriented.
&nbsp;OODBMSs are required to be a <a href="#omg">DBMS</a> and
Object-Oriented
meaning the system must support complex objects, object identity,
&nbsp;encapsulation, types or classes, inheritance, overriding combined
with late binding, extensibility and computational completeness.</li>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Object-Relational (ORDBMS) - traditional relational databases
have been converted to the new Object Relational Database Management
Systems.
&nbsp;This is a combination of both Relational and Object-Oriented
practices
that allow scalability and capabilities of both technologies.
&nbsp;ORDBMSs
provide both a relational or Object-Oriented interface to the
relational
backend database. &nbsp;Most relational providers have already released
their
versions of ORDBMS, e.g. Oracle, IBM.<br>
  </li>
</ul>
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><b>Summary</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">The Unified Modeling
Language (UML) presents both data and behavior
using an Object-Oriented architecture. &nbsp;UML covers the entire
lifecycle of a project thus the popularity and world acceptance of the
model. &nbsp;UML is a model that inherited and encapsulates the best of
previous models into a single product.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">We have also
discussed briefly the differences between the database
types, Relational, Object-Oriented and Object-Relational.
&nbsp;Relational still has market share but will be passed up with the
Object-Relational type.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<hr width="100%" size="2"
 style="font-family: helvetica,arial,sans-serif; margin-left: 0px; margin-right: auto;">
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><b>
Discussion
Questions:</b> &nbsp;Please read the Discussion Question appendix in
the syllabus.<br>
</p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><span
 style="font-weight: bold;">Discussion Question
1:</span>&nbsp;&nbsp;&nbsp; Discuss at least two of the Unified
Modeling
Language's diagrams in detail.<br>
<br>
<span style="font-weight: bold;">Discussion Question 2:&nbsp;</span>&nbsp;&nbsp;
Which model have you seen used
more Entity-Relationship Data Model, Unified Modeling Language or
another model?&nbsp; Why do you think this model is being used
currently.&nbsp; (Please remember, no proprietary / classified
discussions).<br>
<br>
<span style="font-weight: bold;">Discussion Question 3:&nbsp;</span>&nbsp;&nbsp;
Discuss which model
Entity-Relationship Data Model or Unified Modeling Language in your
opinion is the best model and why.</p>
<div style="text-align: left;"></div>
<hr width="100%" size="2"
 style="font-family: helvetica,arial,sans-serif; margin-left: 0px; margin-right: auto;">
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><b>Individual
Assignment</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">Write a 2 - 3 page
paper (at least 300 words per page, <span style="font-weight: bold;">Arial
Font, Size 10</span>) that explains in detail the topic of discussion.
&nbsp;Make sure your resources are declared.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">Object-Oriented
Analysis, Design and Programming are now popular today.
&nbsp;However, most of our databases are Relational. &nbsp;Discuss your
research / findings on the database future. &nbsp;In your opinion, are
databases going to transition from Relational to Object-Oriented,
become a hybrid solution or some other alternative. &nbsp;What types of
analysis, design and development are being targeted in the future?</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<hr width="100%" size="2"
 style="font-family: helvetica,arial,sans-serif; margin-left: 0px; margin-right: auto;">
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><b>Acronyms</b><br>
</p>
<div style="text-align: left;"></div>
<table cellpadding="2" cellspacing="2" border="1" width="100%"
 style="font-family: helvetica,arial,sans-serif; text-align: left; margin-left: 0px; margin-right: auto;">
  <tbody>
    <tr>
      <td valign="top">ER<br>
      </td>
      <td valign="top">Entity Relationship<br>
      </td>
    </tr>
    <tr>
      <td valign="top">OMG<br>
      </td>
      <td valign="top">Object Management Group<br>
      </td>
    </tr>
    <tr>
      <td valign="top">OODBMS<br>
      </td>
      <td valign="top">Object-Oriented Database Management System<br>
      </td>
    </tr>
    <tr>
      <td valign="top">OOPL<br>
      </td>
      <td valign="top">Object-Oriented Programming Language<br>
      </td>
    </tr>
    <tr>
      <td valign="top">ORDBMS<br>
      </td>
      <td valign="top">Object-Relational Database Management System<br>
      </td>
    </tr>
    <tr>
      <td valign="top">RDBMS<br>
      </td>
      <td valign="top">Relational Database Management System<br>
      </td>
    </tr>
    <tr>
      <td valign="top">SQL<br>
      </td>
      <td valign="top">Structured Query Language<br>
      </td>
    </tr>
    <tr>
      <td valign="top">UML<br>
      </td>
      <td valign="top">Unified Modeling Language<br>
      </td>
    </tr>
  </tbody>
</table>
<div style="text-align: left;"><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font> <font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"> </font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><big>References</big></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><big></big></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="uml1"></a><a
 href="http://www.handaweb.com/anthony/portfolio/emarketplace/usecase.html">UML</a>,
http://www.handaweb.com/anthony/portfolio/emarketplace/usecase.html,
Accessed:&nbsp; 20 March 2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="uml2"></a><a
 href="http://www.visual-paradigm.com/UseCaseModeling/">UML</a>,
http://www.visual-paradigm.com/UseCaseModeling/, Accessed:&nbsp; 20
March 2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="uml3"></a><a
 href="http://www.developer.com/design/article.php/2238131">UML</a>,
http://www.developer.com/design/article.php, Accessed:&nbsp; 20 March
2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="history"></a>E.F.
Codd, "Extending the Relational Model to
Capture More Meaning, "ACM Transactions on Database Systems, December
1976, pp.
397 - 424</font><br style="font-family: helvetica,arial,sans-serif;">
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="cardinal"></a><a
 href="http://whatis.techtarget.com/definition/0,,sid9_gci214506,00.html">Cardinal</a>,
http://whatis.techtarget.com/definition/0,,sid9_gci214506,00.html,
Accessed: &nbsp;20 March 2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="cardinality"></a><a
 href="http://whatis.techtarget.com/definition/0,,sid9_gci498885,00.html">Cardinality</a>,
http://whatis.techtarget.com/definition/0,,sid9_gci498885,00.html,
Accessed: &nbsp;20 March 2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="uml"></a>Grady
Booch, James Rumbaugh, Ivan Jacobson, "The
Unified Modeling Language User Guide", ISBN 0-201-57168-4, 1999, p: xx,
15, 16</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="omg"></a><a
 href="http://www.omg.org/">Object Management Group</a>,
http://www.omg.org/, Accessed: &nbsp;11 May 2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="ordbms"></a><a
 href="http://www.acm.org/crossroads/xrds7-3/ordbms.html">Object-Relational
Database Systems - The Road Ahead</a>,
http://www.acm.org/crossroads/xrds7-3/ordbms.html, Accessed: &nbsp;25
June 2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<hr
 style="width: 100%; height: 2px; font-family: helvetica,arial,sans-serif; margin-left: 0px; margin-right: auto;">
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><font color="#008080"><b>Get
Credit Card Information - Use Case / </b></font></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><font color="#008080"><b>Scenario
Example </b></font></font>
</div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Description</li>
  <ul>
    <li>The Get Credit Card Information
Use Case defines the process of how a customer submits their credit
card to the merchant<br>
    </li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Actors</li>
  <ul>
    <li>Customer</li>
    <li>Merchant<br>
    </li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Pre Conditions</li>
  <ul>
    <li>Customer must have a credit card or cash<br>
    </li>
    <li>Customer has already
decided on an item(s) to purchase<br>
    </li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Basic Flow</li>
  <ul>
    <li>1.&nbsp; This use
case begins with a customer performing a checkout, ordering the items
that were selected<br>
    </li>
    <li>2.&nbsp; The customer
is presented a payment form, e.g. credit card data</li>
    <li>3.&nbsp; The customer fills out the credit card data<br>
    </li>
    <li>4.&nbsp; The customer
is presented a mailing and billing form</li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Alternate Flow</li>
  <ul>
    <li>A1-1.&nbsp; At basic
flow step 3, the customer wants to pay cash on delivery (COD)<br>
    </li>
    <li>A1-2.&nbsp; The
customer is presented a COD form.<br>
    </li>
    <li>A1-3.&nbsp; Continue
at basic flow 4.<br>
    </li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Exceptions</li>
  <ul>
    <li>E1.&nbsp; At any
step, an error occurs, this use case ends<br>
    </li>
    <li>E2.&nbsp;
At basic flow step 4, the customer's fails to fill out the form
correct, return to
basic flow 3.&nbsp; After three (3) tries, this use case ends.</li>
    <li>E3.&nbsp;
At alternate step A1-2, the customer's fails to fill out the form
correct, return to alternate step A1-1.&nbsp; After three (3) tries,
this use case ends.</li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Post Conditions</li>
  <ul>
    <li>The customer's credit card and billing information have been
taken.<br>
    </li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Notes</li>
  <ul>
    <li>A
customer is a non-employee of the merchant company.</li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Owners</li>
  <ul>
    <li>(U)&nbsp;
Author:&nbsp; Robert Estey (restey@email.uophx.edu)</li>
    <li>(U)&nbsp;
Organization: University of Phoenix Online</li>
  </ul>
</ul>
<div style="text-align: left;"></div>
<hr
 style="width: 100%; height: 2px; font-family: helvetica,arial,sans-serif; margin-left: 0px; margin-right: auto;">
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">Release 1 of DBM 405
discussed the Semantic Object Data Model (SODM).&nbsp; This was a
technology that
was to little to late.&nbsp; If you have any interest in SODM you can
continue to read.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;">
<hr
 style="width: 100%; height: 2px; margin-left: 0px; margin-right: auto;"><big><big><b>The
Semantic Object
Data Model<br>
(approach to analysis and design)<br>
</b></big></big></div>
<div style="text-align: left;"><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">This document assumes
that the Reader has an understanding of Entity
Relationship (ER) model, diagrams and terminology. &nbsp;We will be
discussing the Semantic Object Data Model (<a href="week1.html#text">Meaning
of the User's Data</a>) and the approach to analysis and design.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"> <b>History</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"> The </font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">S</font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">emantic Object Data
Model (SODM)</font><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">&nbsp;was first
presented in </font><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a
 href="week1.html#text">David
M. Kroenke's</a> book, Database Processing: &nbsp;Fundamentals, Design
&amp; Implementation in 1988. &nbsp;The model was based on concepts
that were developed
and published by <a href="week1.html#history">E.F.
Codd</a>, <a href="week1.html#history2">Michael
Hammer</a> and <a href="week1.html#history2">Dennis
McLeod</a>.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">SODM uses an object
based approach to solving the problem of transforming a computing
problem into
a database design solution. &nbsp;ER and SODM both have similarities as
they retrieve requirements, perform analysis with the client and
construct a
database design that developers can write programs, clients can view
the
blueprints of the project and computing staffs can perform detailed
analysis.
&nbsp;Essentially, ER and SODM are tools that are used by the database
designer
to provide a solution to the requesting client.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><img
 src="erSO.gif" alt="" style="width: 757px; height: 379px;" title=""> <br>
<b><a name="figure1"></a>Figure 1 Database Models</b><br>
<br>
<a href="week1.html#figure1">
Figure 1</a> shows how the ER model and the SODM have similarities when
addressing
the problems and finding a reasonable solution. &nbsp;They both work as
an
interface between applications and design. &nbsp;There are four parts
to
a Semantic Object, the Object, Object Instance and Attributes.
</div>
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"> </font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"> </font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><b>
Semantic&nbsp;Object</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">The Semantic Model
Object is a blueprint that defines the attributes
that object instances have set in the initialized state. &nbsp;An
example of
an Object would be TECHNOLOGY. &nbsp;<a href="week1.html#figure2">Figure
2</a>, illustrates that the object TECHNOLOGY has a template object
that is being replicated into 4 instance objects. &nbsp;Note that the
Semantic Object is all uppercase.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><img
 src="objectsModelA.gif" alt="" style="width: 473px; height: 360px;"
 title=""> <br>
</div>
<div style="text-align: left;"></div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><b><a
 name="figure2"></a>Figure 2 Semantic Object with 4 Object Instances<br>
<br>
</b>
<br>
<a href="week1.html#figure3">Figure
3</a> illustrates that the Object contains 5 attributes within the
Object. &nbsp;All Object Instances will have 5 attributes. &nbsp;The
values of the attributes can be the same or different between the
Objects Instances.<br>
</div>
<div style="text-align: left;"></div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><img
 src="objectsModelB.gif" alt="" style="width: 322px; height: 322px;"
 title=""> <br>
<b><a name="figure3"></a> Figure 3 Semantic Object Anatomy</b><br>
</div>
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><b>Semantic&nbsp;Object
Instance</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">Object Instance is
the actual entity. &nbsp;Once created using the
Object characteristics the Object Instance can add, change or delete
attribute
values. &nbsp;An example of an Object Instance would be <a
 href="http://apache.org">The Apache Group</a>, <a
 href="http://java.sun.com">Java Web Page</a>, <a href="gnu.org">GNU</a>
and <a href="openoffice.org">OpenOffice</a>,
that we saw in <a href="week1.html#figure2">Figure
2</a>. &nbsp;They are all TECHNOLOGY Object's but they are definitely
different as Object Instances. &nbsp;Now you further break down the
object instance into an actual schema which we can now visually
understand, shown in <a href="week1.html#figure4">Figure
4</a>. &nbsp;We will use this example throughout the paper.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><img
 src="objectInstance.gif" alt="" style="width: 360px; height: 539px;"
 title=""> &nbsp; <br>
</div>
<div style="text-align: left;"></div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><b><a
 name="figure4"></a> Figure 4 SODM Object Instance</b><br>
</div>
<div style="text-align: left;"><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><b>Attributes</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">Attributes are the
state values. &nbsp;The attribute value would be
initially be <b>someGroup.us</b>. &nbsp;Later the company changes
names to <b>anotherGroup.com</b>, the current attribute value.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font>
</div>
<table cellpadding="2" cellspacing="2" border="1" width="100%"
 style="font-family: helvetica,arial,sans-serif; text-align: left; margin-left: 0px; margin-right: auto;">
  <tbody>
    <tr>
      <td valign="top" align="center"><b>Simple<br>
      </b> </td>
      <td valign="top">Single value<br>
      </td>
      <td valign="top">name = Computing Visualization<br>
webSite = someGroup.us<br>
      </td>
    </tr>
    <tr>
      <td valign="top" align="center"><b>Group<br>
      </b> </td>
      <td valign="top">Composite of values<br>
      </td>
      <td valign="top">address<br>
street = 1313 Mockingbird Lane<br>
city = Maricopa<br>
state = AZ<br>
zipCode = 85239<br>
      </td>
    </tr>
    <tr>
      <td valign="top" align="center"><b>Object<br>
      </b> </td>
      <td valign="top">Attribute relationships between objects<br>
      </td>
      <td valign="top">Apache, Java, Linux, Projects Objects<br>
      </td>
    </tr>
  </tbody>
</table>
<div style="text-align: left;"></div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><a
 name="table1"></a><b>Table 1 Semantic Object Attributes</b><br>
</div>
<div style="text-align: left;"><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">There are three types
of Semantic Object Attributes, Simple, Group and Object as the <a
 href="week1.html#table1">Table
1</a> illustrates above. &nbsp;</font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">A simple attribute
has
a key and value, very much like a &nbsp;hashtable. &nbsp;The attributes
name and website are the only simple attributes for the SODM instance
in <a href="week1.html#figure4">Figure
4</a>. &nbsp;Group attributes have a key and more than one value.
&nbsp;The attributes founders and address are the only group
attributes. &nbsp;Object attributes are associated with an object,
which can have zero to many attributes. &nbsp;The Object attributes are
all the attributes in green boxes. &nbsp;<img src="greenBox.gif" alt=""
 style="width: 78px; height: 27px;" align="top" title=""> </font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"> </font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><b> Cardinality /
Multiplicity</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><img
 src="http://whatis.techtarget.com/images/spacer.gif" height="5"
 width="1"> </font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a
 href="week1.html#cardinal">
Cardinal</a> refers to a basic or primary value. Examples of cardinal
numbers are 1, 7, 9, and 123. A cardinal rule is a rule that is basic
or essential. Cardinal numbers can be contrasted with ordinal numbers.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><!-- end definition --><!-- This tag is only used when a boombox ad is in use -->
</div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;">The
term
cardinality refers
to the number of Cardinal (basic) members in a set. Cardinality can be
finite (a non negative integer) or infinite. For example, the
cardinality of the
set of people in the United States is approximately 270,000,000.
&nbsp;The cardinality of the set of integers is denumerable infinite.<br>
</p>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li>Minimum cardinality - the minimum number of Objects (object
instance) attributes that must exist for the object to be valid.</li>
  <li>Maximum cardinality - the maximum number of Objects (object
instance) attributes that must exist for the object to be valid.</li>
</ul>
<div style="text-align: left;"></div>
<table cellpadding="2" cellspacing="2" border="1" width="100%"
 style="font-family: helvetica,arial,sans-serif; text-align: left; margin-left: 0px; margin-right: auto;">
  <tbody>
    <tr>
      <td valign="top" align="center"><b>Cardinality<br>
      </b> </td>
      <td valign="top" align="center"><b>Meaning<br>
      </b> </td>
      <td valign="top" align="center"><b>Example<br>
      </b> </td>
    </tr>
    <tr>
      <td valign="top">0..1<br>
      </td>
      <td valign="top">0 (off) and 1 (on)<br>
      </td>
      <td valign="top">electrical switch<br>
      </td>
    </tr>
    <tr>
      <td valign="top">1..1<br>
      </td>
      <td valign="top">1 and only 1<br>
      </td>
      <td valign="top">social security number<br>
      </td>
    </tr>
    <tr>
      <td valign="top">0..N<br>
      </td>
      <td valign="top">0 through many<br>
      </td>
      <td valign="top">people in an elevator<br>
      </td>
    </tr>
    <tr>
      <td valign="top">1..N<br>
      </td>
      <td valign="top">1 through many<br>
      </td>
      <td valign="top">sails on a sailboat<br>
      </td>
    </tr>
    <tr>
      <td valign="top">9..9<br>
      </td>
      <td valign="top">9 and only 9<br>
      </td>
      <td valign="top">baseball team on the field<br>
      </td>
    </tr>
  </tbody>
</table>
<div style="text-align: left;"></div>
<div style="font-family: helvetica,arial,sans-serif; text-align: left;"><b><a
 name="table2"></a>Table 2 Cardinality Example</b><br>
</div>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big>Paired
Attributes<br>
</big></p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big>
<small>SODM
has no one way references between objects. &nbsp;All relations are
bi-directional or called paired attributes. &nbsp;Using our <a
 href="week1.html#figure4">Figure
4</a> example above we can see that the Object Instance has several
bi-directional relationships, one relationship would be Java.</small></big></p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big>Identifiers</big></p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big><small>Identifiers
can be one (Object Identifier) or many (Group Identifier) attributes
that uniquely identify an Object Instance and marked with an ID in
front of the attribute. &nbsp;If the ID characters have an underline,
this indicates that
the Identifier is unique. &nbsp;<a href="week1.html#figure4">Figure
4</a> illustrates that the non-unique name attribute is an Object
Identifier (single attribute) with ID preceding the attribute.
&nbsp;Two more examples of Identifiers would be the Internal Revenue
Service (IRS) using your social security number as an Object Identifier
or your company using your Last
and First name as a Group Identifier. &nbsp;Think of an Identifier as a
Primary Key that locates a specific record.<br>
</small></big><br>
<big>Attribute Domain<br>
<small><br>
The Attribute Domain is the description of all the possible attribute
values, boundaries and type. &nbsp; A simple attribute domain could be
a
rating scale, e.g. &nbsp;How would you rate the service, 1 - bad, 10 -
excellent.
&nbsp;This particular attribute would be described as what the customer
would rate the service, Integer type and a value greater than or equal
to
1 or less than or equal to 10.</small><br>
</big></p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big>Semantic
Object
View</big><big><br>
</big></p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big><small>Semantic
Object Views or Views are how an object is accessible to an outside
source, including the attributes. &nbsp;This is a common practice in
databases today. &nbsp;One
example would be a customer can log on a website with their personal
login
name and password. &nbsp;Then the system will display attributes that
only
the customer should have access to view. &nbsp;While being in the same
database
the vendor can only work on system settings and not look into others
personal
information. &nbsp;Views are dynamically easy to setup and offer an
indirect
form of security.<br>
</small></big></p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big>Objects<br>
</big></p>
<div style="text-align: left;"></div>
<p style="font-family: helvetica,arial,sans-serif; text-align: left;"><big><small>The
Semantic Model has seven types of objects. &nbsp;The listing below
briefly describes each type.</small><br>
</big></p>
<div style="text-align: left;"></div>
<ul style="font-family: helvetica,arial,sans-serif; text-align: left;">
  <li><big>Simple</big> - objects contain only simple values in all
attributes and have no multi-value and no object attributes.<br>
  </li>
  <li><big>Composite <small>- contains one or more multi-value and no
object attributes.</small></big></li>
  <li><big>Compound<small> - contains at least one object attribute.</small></big></li>
  <li><big>Hybrid <small>- combination of objects of two types, e.g. a
multi-value group and object attribute.</small></big></li>
  <li><big>Association <small>- merges two or more object relations.</small></big></li>
  <li><big>Parent / Subtype <small>- decomposing attributes into new
objects that are hierarchical structured.</small></big></li>
  <li><big><a href="http://dictionary.reference.com/search?q=archetype">Archetype</a>
/ Version - <small>original, </small></big>prototype, model that
other similar things are patterned.</li>
</ul>
<div style="text-align: left;"><font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><span
 style="font-weight: bold;">Semantic Summary</span></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">The Semantic Object
Data Model (SODM) is A DATA MODEL, nothing more.
&nbsp;SODM defines objects, attributes and relationships very much like
the Entity-Relationship (ER) Data Model with an Object-Oriented
approach. &nbsp;Both ER and SODM
don't show behavior. &nbsp;SODM is has never taken off in the industry
because
the model does nothing more than an ER model and doesn't fulfill all
the
Object-Oriented Programming needs. &nbsp;SODM is a model that was to
little
to late.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><b>Semantic Object
Model Tool</b></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;">The following link is
a site that has a SODM tool: &nbsp;<a
 href="http://www.tabledesigner.com/som.htm#">http://www.tabledesigner.com/som.htm#</a></font><font
 face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"> </font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><span
 style="font-weight: bold;">Semantic Object Model References</span></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="text"></a>David
M. Kroenke, Database Processing:
&nbsp;Fundamentals, Design &amp; Implementation, Seventh Edition, 2000</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="history2"></a>Michael
Hammer and Dennis McLeod, "Database
Description with SDM: &nbsp;A semantic Database model, "ACM
Transactions on Database
Systems, September 1981, pp. 351 - 86.</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="archetype"></a><a
 href="http://dictionary.reference.com/search?q=archetype">Archetype</a>,
http://dictionary.reference.com/search?q=archetype, Accessed: &nbsp;09
April 2003</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"><a name="stereotype"></a><a
 href="http://www.microtool.de/objectif/en/sp_stereotyp.htm">Stereotype</a>,
http://www.microtool.de/objectif/en/sp_stereotyp.htm, Accessed:&nbsp;
17 February 2004</font><br>
<font face="Helvetica, Arial, sans-serif"
 style="font-family: helvetica,arial,sans-serif;"></font><br
 style="font-family: helvetica,arial,sans-serif;">
</div>
<br style="font-family: helvetica,arial,sans-serif;">
</center>
</body>
</html>
